// Made by Liam Branch
// References:
// https://www.construct.net/en/forum/construct-3/scripting-51/script-wait-seconds-every-161464
// https://www.construct.net/en/forum/construct-3/scripting-51/wait-few-seconds-execute-150501
// https://www.construct.net/en/forum/construct-3/scripting-51/turn-based-battle-system-wait-154350
// https://www.construct.net/en/make-games/manuals/construct-3/scripting/scripting-reference/object-interfaces/ibehaviorinstance
// https://www.construct.net/en/make-games/manuals/construct-3/scripting/scripting-reference/behavior-interfaces/platform
// https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key
// https://stackoverflow.com/questions/14389864/javascript-html5-making-a-canvas-animation-using-wasd-to-move-around-a-rectang

import * as Utils from "./utilities.js"; // IMPORT CALLS Import any other script files here, e.g.: import * as myModule from "./mymodule.js";
let game_active = true; let game_active1 = true; let game_active2 = true; let playerHp = 3; let player = null; let gauntlet = null; // GLOBALS

runOnStartup(async runtime => { // Code to run on the loading screen. Note layouts, objects etc. are not yet available.
	runtime.addEventListener("beforeprojectstart", () => OnBeforeProjectStart(runtime));});
async function OnBeforeProjectStart(runtime){// Code to run just before 'On start of layout' on the first layout. Loading has finished and initial instances are created and available to use here.
	console.log(runtime.objects.HealthBar); runtime.addEventListener("tick", () => Tick(runtime));}
function playerOpacity(v){ if(player && gauntlet) {player.opacity = v; gauntlet.opacity = v}}
async function hurtPlayer(ms) { game_active = false; playerHp--; var flashes = 5; for(var i = 0; i<flashes; i++) { playerOpacity(0); await Utils.mySleep(ms/(flashes*2)); playerOpacity(1); await Utils.mySleep(ms/(flashes*2));} game_active = true; }
async function healPlayer(ms) { game_active1 = false; await Utils.mySleep(ms); if(playerHp < 3) playerHp++; game_active1 = true; }
function Tick(runtime) { // Code to run every tick
	player = runtime.objects.Scouty.getFirstInstance();
	gauntlet = runtime.objects.gauntlet.getFirstInstance();
	if(runtime.layout != "GameOver" && player) {
		MovePlayer(runtime);
		const HealthBar = runtime.objects.HealthBar.getFirstInstance(); // HEALTH BAR 
		if(game_active) {
			for(const spikeInstance of runtime.objects.spike.instances()) if(player.testOverlap(spikeInstance) && game_active) hurtPlayer(1000);
			for(const beeInstance of runtime.objects.workerbee.instances()) if(player.testOverlap(beeInstance) && game_active) hurtPlayer(1000);
			for(const turret_bulletInstance of runtime.objects.turret_bullet.instances()) if(player.testOverlap(turret_bulletInstance) && game_active) hurtPlayer(1000);
			for(const turret2Instance of runtime.objects.turret2.instances()) if(player.testOverlap(turret2Instance) && game_active) hurtPlayer(1000);
			for(const turretInstance of runtime.objects.turret.instances()) if(player.testOverlap(turretInstance) && game_active) hurtPlayer(1000);
			for(const queenBlastInstance of runtime.objects.queenBlast.instances())  if(player.testOverlap(queenBlastInstance) && game_active) hurtPlayer(1000);
			for(const deadSpace of runtime.objects.deadspace.instances()) if(player.testOverlap(deadSpace) && game_active) {hurtPlayer(1000); player.x = 161; player.y = 860;}
		}
		if(game_active1) healPlayer(5000);
		if(playerHp > 0){ HealthBar.width = playerHp * 68;}
		if(playerHp <= 0){ playerHp = 0; player.destroy(); runtime.goToLayout("GameOver");}
// 		for(const flagInstance of runtime.objects.Flag.instances()) if(player.testOverlap(flagInstance)) { runtime.goToLayout(runtime.layout.index + 1); player.destroy(); player = runtime.objects.Scouty.getFirstInstance();}
	}
}
function MovePlayer(runtime) {
	const keyboard = runtime.keyboard; const mouse = runtime.mouse;
	if(!player) return;
	var playerBehavior = player.behaviors.Platform;
// 	console.log(player.behaviors.Platform);
	if (keyboard.isKeyDown(87)) playerBehavior.simulateControl("jump");
	if (keyboard.isKeyDown(68)) {playerBehavior.simulateControl("right"); if(player.width > 0) player.width = -1*player.width;}
	if (keyboard.isKeyDown(65)) {playerBehavior.simulateControl("left"); if(player.width < 0) player.width = -1*player.width;}
	gauntlet.angle = Utils.angleTo(gauntlet.x, gauntlet.y, mouse.getMouseX(), mouse.getMouseY());
// 	if (runtime.globalVars.GravityInverted) { if(player.height>0) player.height = -1*player.height; if(playerBehavior.gravity>0) { playerBehavior.gravity = -1500; console.log(playerBehavior.gravity);} } else { if(player.height<0) player.height = -1*player.height; if(playerBehavior.gravity<0) playerBehavior.gravity = 1500; }
}